Index: npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest
===================================================================
--- npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision cd8630be6536b27ae1c762184795ee87723202ab)
+++ npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision 1ebb340be23e45ead361b729734f0e82007af6bd)
@@ -14286,5 +13869,5 @@
    d(auto_qmail,"bin",auto_uido,auto_gidq,0755);
    d(auto_qmail,"boot",auto_uido,auto_gidq,0755);
-@@ -55,6 +56,8 @@
+@@ -55,10 +61,20 @@
    d(auto_qmail,"queue/bounce",auto_uids,auto_gidq,0700);
  
@@ -14295,5 +13878,17 @@
    dsplit("queue/local",auto_uids,0700);
    dsplit("queue/remote",auto_uids,0700);
-@@ -89,6 +92,7 @@
+ 
++  for (cc = 0;cc < SUPPL_CHANNELS;++cc)
++  {
++      char adbuf[100];
++
++      sprintf(adbuf,"queue/" QDIR_BASENAME "%d", cc);
++      dsplit(adbuf,auto_uids,0700);
++  }
++
+   d(auto_qmail,"queue/lock",auto_uidq,auto_gidq,0750);
+   z(auto_qmail,"queue/lock/tcpto",1024,auto_uidr,auto_gidq,0644);
+   z(auto_qmail,"queue/lock/sendmutex",0,auto_uids,auto_gidq,0600);
+@@ -89,6 +105,7 @@
    c(auto_qmail,"doc","TEST.receive",auto_uido,auto_gidq,0644);
    c(auto_qmail,"doc","REMOVE.sendmail",auto_uido,auto_gidq,0644);
@@ -14303,5 +13898,5 @@
    c(auto_qmail,"doc","PIC.local2ext",auto_uido,auto_gidq,0644);
    c(auto_qmail,"doc","PIC.local2local",auto_uido,auto_gidq,0644);
-@@ -104,13 +108,26 @@
+@@ -104,13 +121,26 @@
    c(auto_qmail,"bin","qmail-start",auto_uido,auto_gidq,0700);
    c(auto_qmail,"bin","qmail-getpw",auto_uido,auto_gidq,0711);
@@ -14330,5 +13925,5 @@
    c(auto_qmail,"bin","qmail-inject",auto_uido,auto_gidq,0755);
    c(auto_qmail,"bin","predate",auto_uido,auto_gidq,0755);
-@@ -127,6 +144,7 @@
+@@ -127,6 +157,7 @@
    c(auto_qmail,"bin","qmail-qmqpd",auto_uido,auto_gidq,0755);
    c(auto_qmail,"bin","qmail-qmtpd",auto_uido,auto_gidq,0755);
@@ -14338,5 +13933,5 @@
    c(auto_qmail,"bin","tcp-env",auto_uido,auto_gidq,0755);
    c(auto_qmail,"bin","qreceipt",auto_uido,auto_gidq,0755);
-@@ -143,6 +161,9 @@
+@@ -143,6 +174,9 @@
    c(auto_qmail,"bin","qail",auto_uido,auto_gidq,0755);
    c(auto_qmail,"bin","elq",auto_uido,auto_gidq,0755);
@@ -14348,5 +13943,5 @@
    c(auto_qmail,"man/man5","addresses.5",auto_uido,auto_gidq,0644);
    c(auto_qmail,"man/cat5","addresses.0",auto_uido,auto_gidq,0644);
-@@ -198,6 +219,18 @@
+@@ -198,6 +232,18 @@
    c(auto_qmail,"man/cat1","tcp-env.0",auto_uido,auto_gidq,0644);
  
@@ -14369,5 +13964,5 @@
 diff -ruN ../netqmail-1.06-original/hmac_md5.c netqmail-1.06/hmac_md5.c
 --- ../netqmail-1.06-original/hmac_md5.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/hmac_md5.c	2016-11-22 21:03:57.114528032 +0100
++++ netqmail-1.06/hmac_md5.c	2019-02-27 20:57:13.391025058 +0100
 @@ -0,0 +1,76 @@
 +#include "global.h"
@@ -14449,5 +14044,5 @@
 diff -ruN ../netqmail-1.06-original/hmac_md5.h netqmail-1.06/hmac_md5.h
 --- ../netqmail-1.06-original/hmac_md5.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/hmac_md5.h	2016-11-22 21:03:57.114528032 +0100
++++ netqmail-1.06/hmac_md5.h	2019-02-27 20:57:13.391025058 +0100
 @@ -0,0 +1,11 @@
 +
@@ -14464,6 +14059,40 @@
 diff -ruN ../netqmail-1.06-original/install-big.c netqmail-1.06/install-big.c
 --- ../netqmail-1.06-original/install-big.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/install-big.c	2016-11-22 21:04:38.822137319 +0100
-@@ -89,6 +89,7 @@
++++ netqmail-1.06/install-big.c	2019-06-26 16:39:31.574826959 +0200
+@@ -4,6 +4,9 @@
+ #include "fmt.h"
+ #include "fifo.h"
+ 
++#include <stdio.h>
++#include "channels.h"
++
+ char buf[100 + FMT_ULONG];
+ 
+ void dsplit(base,uid,mode)
+@@ -29,6 +32,8 @@
+ 
+ void hier()
+ {
++  int cc;
++
+   h(auto_qmail,auto_uido,auto_gidq,0755);
+ 
+   d(auto_qmail,"control",auto_uido,auto_gidq,0755);
+@@ -59,6 +64,14 @@
+   dsplit("queue/local",auto_uids,0700);
+   dsplit("queue/remote",auto_uids,0700);
+ 
++  for (cc = 0;cc < SUPPL_CHANNELS;++cc)
++  {
++      char adbuf[100];
++
++      sprintf(adbuf,"queue/" QDIR_BASENAME "%d", cc);
++      dsplit(adbuf,auto_uids,0700);
++  }
++
+   d(auto_qmail,"queue/lock",auto_uidq,auto_gidq,0750);
+   z(auto_qmail,"queue/lock/tcpto",1024,auto_uidr,auto_gidq,0644);
+   z(auto_qmail,"queue/lock/sendmutex",0,auto_uids,auto_gidq,0600);
+@@ -89,6 +102,7 @@
    c(auto_qmail,"doc","TEST.receive",auto_uido,auto_gidq,0644);
    c(auto_qmail,"doc","REMOVE.sendmail",auto_uido,auto_gidq,0644);
@@ -14473,5 +14102,5 @@
    c(auto_qmail,"doc","PIC.local2ext",auto_uido,auto_gidq,0644);
    c(auto_qmail,"doc","PIC.local2local",auto_uido,auto_gidq,0644);
-@@ -108,9 +109,13 @@
+@@ -108,9 +122,13 @@
    c(auto_qmail,"bin","qmail-rspawn",auto_uido,auto_gidq,0711);
    c(auto_qmail,"bin","qmail-clean",auto_uido,auto_gidq,0711);
@@ -14487,5 +14116,5 @@
    c(auto_qmail,"bin","qmail-inject",auto_uido,auto_gidq,0755);
    c(auto_qmail,"bin","predate",auto_uido,auto_gidq,0755);
-@@ -133,6 +138,7 @@
+@@ -133,6 +151,7 @@
    c(auto_qmail,"bin","qsmhook",auto_uido,auto_gidq,0755);
    c(auto_qmail,"bin","qbiff",auto_uido,auto_gidq,0755);
@@ -14497,5 +14126,5 @@
 diff -ruN ../netqmail-1.06-original/ip.h netqmail-1.06/ip.h
 --- ../netqmail-1.06-original/ip.h	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/ip.h	2016-11-22 21:03:57.115527999 +0100
++++ netqmail-1.06/ip.h	2019-02-27 20:57:13.392025048 +0100
 @@ -2,6 +2,7 @@
  #define IP_H
@@ -14508,5 +14137,5 @@
 diff -ruN ../netqmail-1.06-original/ipalloc.h netqmail-1.06/ipalloc.h
 --- ../netqmail-1.06-original/ipalloc.h	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/ipalloc.h	2016-11-22 21:03:57.115527999 +0100
++++ netqmail-1.06/ipalloc.h	2019-02-27 20:57:13.392025048 +0100
 @@ -3,7 +3,15 @@
  
@@ -14527,5 +14156,5 @@
 diff -ruN ../netqmail-1.06-original/ipme.c netqmail-1.06/ipme.c
 --- ../netqmail-1.06-original/ipme.c	2007-11-30 21:22:54.000000000 +0100
-+++ netqmail-1.06/ipme.c	2016-11-22 21:03:57.115527999 +0100
++++ netqmail-1.06/ipme.c	2019-02-27 20:57:13.392025048 +0100
 @@ -14,23 +14,65 @@
  #include "ipalloc.h"
@@ -14742,5 +14371,5 @@
 diff -ruN ../netqmail-1.06-original/ipme.h netqmail-1.06/ipme.h
 --- ../netqmail-1.06-original/ipme.h	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/ipme.h	2016-11-22 21:03:57.115527999 +0100
++++ netqmail-1.06/ipme.h	2019-02-27 20:57:13.392025048 +0100
 @@ -4,7 +4,7 @@
  #include "ip.h"
@@ -14754,5 +14383,5 @@
 diff -ruN ../netqmail-1.06-original/ipmeprint.c netqmail-1.06/ipmeprint.c
 --- ../netqmail-1.06-original/ipmeprint.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/ipmeprint.c	2016-11-22 21:03:57.115527999 +0100
++++ netqmail-1.06/ipmeprint.c	2019-02-27 20:57:13.392025048 +0100
 @@ -3,12 +3,15 @@
  #include "ip.h"
@@ -14794,5 +14423,5 @@
 diff -ruN ../netqmail-1.06-original/ipmetest.c netqmail-1.06/ipmetest.c
 --- ../netqmail-1.06-original/ipmetest.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/ipmetest.c	2016-11-22 21:03:57.115527999 +0100
++++ netqmail-1.06/ipmetest.c	2019-02-27 20:57:13.392025048 +0100
 @@ -0,0 +1,38 @@
 +#include "subfd.h"
@@ -14836,5 +14465,5 @@
 diff -ruN ../netqmail-1.06-original/macros.h netqmail-1.06/macros.h
 --- ../netqmail-1.06-original/macros.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/macros.h	2016-11-22 21:03:57.115527999 +0100
++++ netqmail-1.06/macros.h	2019-02-27 20:57:13.392025048 +0100
 @@ -0,0 +1,25 @@
 +/*
@@ -14865,5 +14494,5 @@
 diff -ruN ../netqmail-1.06-original/maildirflags.c netqmail-1.06/maildirflags.c
 --- ../netqmail-1.06-original/maildirflags.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/maildirflags.c	2016-11-22 21:03:57.116527965 +0100
++++ netqmail-1.06/maildirflags.c	2019-02-27 20:57:13.392025048 +0100
 @@ -0,0 +1,23 @@
 +/*
@@ -14892,5 +14521,5 @@
 diff -ruN ../netqmail-1.06-original/maildirgetquota.c netqmail-1.06/maildirgetquota.c
 --- ../netqmail-1.06-original/maildirgetquota.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/maildirgetquota.c	2016-11-22 21:03:57.116527965 +0100
++++ netqmail-1.06/maildirgetquota.c	2019-02-27 20:57:13.393025036 +0100
 @@ -0,0 +1,50 @@
 +/*
@@ -14946,5 +14575,5 @@
 diff -ruN ../netqmail-1.06-original/maildirgetquota.h netqmail-1.06/maildirgetquota.h
 --- ../netqmail-1.06-original/maildirgetquota.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/maildirgetquota.h	2016-11-22 21:03:57.116527965 +0100
++++ netqmail-1.06/maildirgetquota.h	2019-02-27 20:57:13.393025036 +0100
 @@ -0,0 +1,30 @@
 +#ifndef	maildirgetquota_h
@@ -14980,5 +14609,5 @@
 diff -ruN ../netqmail-1.06-original/maildirmisc.h netqmail-1.06/maildirmisc.h
 --- ../netqmail-1.06-original/maildirmisc.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/maildirmisc.h	2016-11-22 21:03:57.116527965 +0100
++++ netqmail-1.06/maildirmisc.h	2019-02-27 20:57:13.393025036 +0100
 @@ -0,0 +1,145 @@
 +#ifndef	maildirmisc_h
@@ -15129,5 +14758,5 @@
 diff -ruN ../netqmail-1.06-original/maildiropen.c netqmail-1.06/maildiropen.c
 --- ../netqmail-1.06-original/maildiropen.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/maildiropen.c	2016-11-22 21:03:57.116527965 +0100
++++ netqmail-1.06/maildiropen.c	2019-02-27 20:57:13.393025036 +0100
 @@ -0,0 +1,133 @@
 +/*
@@ -15266,5 +14895,5 @@
 diff -ruN ../netqmail-1.06-original/maildirparsequota.c netqmail-1.06/maildirparsequota.c
 --- ../netqmail-1.06-original/maildirparsequota.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/maildirparsequota.c	2016-11-22 21:03:57.116527965 +0100
++++ netqmail-1.06/maildirparsequota.c	2019-02-27 20:57:13.393025036 +0100
 @@ -0,0 +1,44 @@
 +/*
@@ -15314,5 +14943,5 @@
 diff -ruN ../netqmail-1.06-original/maildirquota.c netqmail-1.06/maildirquota.c
 --- ../netqmail-1.06-original/maildirquota.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/maildirquota.c	2016-11-22 21:03:57.116527965 +0100
++++ netqmail-1.06/maildirquota.c	2019-02-27 20:57:13.393025036 +0100
 @@ -0,0 +1,685 @@
 +/*
@@ -16003,5 +15632,5 @@
 diff -ruN ../netqmail-1.06-original/maildirquota.h netqmail-1.06/maildirquota.h
 --- ../netqmail-1.06-original/maildirquota.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/maildirquota.h	2016-11-22 21:03:57.117527932 +0100
++++ netqmail-1.06/maildirquota.h	2019-02-27 20:57:13.393025036 +0100
 @@ -0,0 +1,45 @@
 +#ifndef	maildirquota_h
@@ -16052,5 +15681,5 @@
 diff -ruN ../netqmail-1.06-original/md5.h netqmail-1.06/md5.h
 --- ../netqmail-1.06-original/md5.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/md5.h	2016-11-22 21:03:57.117527932 +0100
++++ netqmail-1.06/md5.h	2019-02-27 20:57:13.394025025 +0100
 @@ -0,0 +1,49 @@
 +/* MD5.H - header file for MD5C.C
@@ -16105,5 +15734,5 @@
 diff -ruN ../netqmail-1.06-original/md5c.c netqmail-1.06/md5c.c
 --- ../netqmail-1.06-original/md5c.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/md5c.c	2016-11-22 21:03:57.117527932 +0100
++++ netqmail-1.06/md5c.c	2019-02-27 20:57:13.394025025 +0100
 @@ -0,0 +1,334 @@
 +/* MD5C.C - RSA Data Security, Inc., MD5 message-digest algorithm
@@ -16443,5 +16072,5 @@
 diff -ruN ../netqmail-1.06-original/mess822.h netqmail-1.06/mess822.h
 --- ../netqmail-1.06-original/mess822.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/mess822.h	2016-11-22 21:03:57.117527932 +0100
++++ netqmail-1.06/mess822.h	2019-02-27 20:57:13.394025025 +0100
 @@ -0,0 +1,55 @@
 +/*
@@ -16502,5 +16131,5 @@
 diff -ruN ../netqmail-1.06-original/mess822_ok.c netqmail-1.06/mess822_ok.c
 --- ../netqmail-1.06-original/mess822_ok.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/mess822_ok.c	2016-11-22 21:03:57.117527932 +0100
++++ netqmail-1.06/mess822_ok.c	2019-02-27 20:57:13.394025025 +0100
 @@ -0,0 +1,55 @@
 +/*
@@ -16561,5 +16190,5 @@
 diff -ruN ../netqmail-1.06-original/numlib.h netqmail-1.06/numlib.h
 --- ../netqmail-1.06-original/numlib.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/numlib.h	2016-11-22 21:03:57.117527932 +0100
++++ netqmail-1.06/numlib.h	2019-02-27 20:57:13.394025025 +0100
 @@ -0,0 +1,45 @@
 +#ifndef	numlib_h
@@ -16610,5 +16239,5 @@
 diff -ruN ../netqmail-1.06-original/overmaildirquota.c netqmail-1.06/overmaildirquota.c
 --- ../netqmail-1.06-original/overmaildirquota.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/overmaildirquota.c	2016-11-22 21:03:57.117527932 +0100
++++ netqmail-1.06/overmaildirquota.c	2019-02-27 20:57:13.394025025 +0100
 @@ -0,0 +1,41 @@
 +/*
@@ -16655,5 +16284,5 @@
 diff -ruN ../netqmail-1.06-original/policy.c netqmail-1.06/policy.c
 --- ../netqmail-1.06-original/policy.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/policy.c	2016-11-22 21:03:57.118527899 +0100
++++ netqmail-1.06/policy.c	2019-02-27 20:57:13.395025014 +0100
 @@ -0,0 +1,1210 @@
 +/*
@@ -17869,5 +17498,5 @@
 diff -ruN ../netqmail-1.06-original/policy.h netqmail-1.06/policy.h
 --- ../netqmail-1.06-original/policy.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/policy.h	2016-11-22 21:03:57.118527899 +0100
++++ netqmail-1.06/policy.h	2019-02-27 20:57:13.395025014 +0100
 @@ -0,0 +1,6 @@
 +#ifndef __POLICY_H_
@@ -17879,5 +17508,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-clean.c netqmail-1.06/qmail-clean.c
 --- ../netqmail-1.06-original/qmail-clean.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-clean.c	2016-11-22 21:03:57.118527899 +0100
++++ netqmail-1.06/qmail-clean.c	2019-02-27 20:57:13.395025014 +0100
 @@ -73,22 +73,26 @@
     if (line.len < 7) { respond("x"); continue; }
@@ -17914,5 +17543,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-control.9 netqmail-1.06/qmail-control.9
 --- ../netqmail-1.06-original/qmail-control.9	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-control.9	2016-11-28 17:36:57.350660496 +0100
++++ netqmail-1.06/qmail-control.9	2019-02-27 20:57:13.395025014 +0100
 @@ -20,7 +20,11 @@
  
@@ -17991,5 +17620,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-dk.9 netqmail-1.06/qmail-dk.9
 --- ../netqmail-1.06-original/qmail-dk.9	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/qmail-dk.9	2018-04-03 14:46:51.371411632 +0200
++++ netqmail-1.06/qmail-dk.9	2019-02-27 20:57:13.395025014 +0100
 @@ -0,0 +1,164 @@
 +.TH qmail-dk 8
@@ -18159,5 +17788,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-dk.c netqmail-1.06/qmail-dk.c
 --- ../netqmail-1.06-original/qmail-dk.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/qmail-dk.c	2018-04-03 14:46:51.372411636 +0200
++++ netqmail-1.06/qmail-dk.c	2019-02-27 20:57:13.396025003 +0100
 @@ -0,0 +1,866 @@
 +/*
@@ -19029,6 +18658,6 @@
 diff -ruN ../netqmail-1.06-original/qmail-dkim.9 netqmail-1.06/qmail-dkim.9
 --- ../netqmail-1.06-original/qmail-dkim.9	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/qmail-dkim.9	2018-04-03 14:46:51.372411636 +0200
-@@ -0,0 +1,321 @@
++++ netqmail-1.06/qmail-dkim.9	2020-04-09 19:45:28.421566373 +0200
+@@ -0,0 +1,322 @@
 +.TH qmail-dkim 8
 +.SH NAME
@@ -19061,5 +18690,5 @@
 +variable, it is removed and replaced by the domain name in the From: header.
 +If, after substituting the %, that file does not exist, the % character will be
-+removed. If the private key file does not exist and does not have a % character,
++removed. If a private key file does not exist and does not have a % character,
 +the message will be rejected with error 35. The selector (s=) will be taken from
 +the basename of the file. The private key should be created by 
@@ -19107,9 +18736,6 @@
 +.BR DKIMSIGNOPTIONS.
 +.B qmail-dkim
-+uses the domain found in the Sender: header to set the domain tag. If not it uses the
-+From: header. You can override this by setting 
-+.B DKIMDOMAIN
-+environment variable.
-+.B DKIMDOMAIN
++uses the domain found in the Return-Path, Sender, From headers to set the domain tag.
++If not it uses the \fBDKIMDOMAIN\fR environment variable. \fBDKIMDOMAIN\fR
 +can be set to an email address or a domain (without the at sign).
 +
@@ -19120,9 +18746,10 @@
 +letter, where A is the first return status (DKIM_SUCCESS), B is the
 +second (DKIM_FINISHED_BODY), etc.  The letter should be uppercase if you
-+want a permanent error to be returned, and lowercase if
-+you want a temporary error to be returned (exit code 88). If you omit the letter,
-+\fBqmail-dkim\fR will not issue any error inspite of DKIM verification failure. It
-+will return success and the email will get delivered. The complete set of letters
-+with the corresponding return status is given below
++want a permanent error to be returned, and lowercase if you want a temporary
++error to be returned (exit code 88). If you omit the letter, qmail-dkim will
++not issue any error inspite of DKIM verification failure. It will return
++success and the email will get delivered.
++
++The complete set of letters with the corresponding return status is given below
 +
 + A - DKIM_SUCCESS                        - Function executed successfully
@@ -19191,5 +18818,7 @@
 +.B DKIMVERIFY
 +to an empty string. If you want to check all message's From header in signature set the
-+\fBUNSIGNED_FROM\fR environment variable to an empty string.
++\fBUNSIGNED_FROM\fR environment variable to an empty string. If you want to check messages
++without signed subject header, set \fBUNSIGNED_SUBJECT\fR environment variable. If you want
++to honor body lengh tag (l=), set \fBHONOR_BODYLENGTHTAG\fR environment variable.
 +
 +qmail-dkim supports signing practice which can be additonall checked when a signature
@@ -19211,5 +18840,5 @@
 +set the environment variable 
 +.BR DKIMPRACTICE="ST" .
-+If you want automatic behaviour, set DKIMADSPERROR to an empty string. In this case ADSP/SSP will be used when return code
++If you want automatic behaviour, set DKIMPRACTICE to an empty string. In this case ADSP/SSP will be used when return code
 +matches "FGHIJKLMNPQRSTUVWX".
 +.B qmail-dkim
@@ -19266,5 +18895,5 @@
 +containing a list of domains which you know are sure not to sign messages using DKIM.
 +If a message comes from a domain listed in
-+.IR signaturedomains ,
++.IR nosignaturedomains ,
 +and does not have a DKIM-Signature header, 
 +.B qmail-dkim
@@ -19278,6 +18907,6 @@
 +Typically, you would sign messages generated on-host by setting
 +.B DKIMSIGN
-+in the environment before running an email program.  DKIMSIGN will be carried
-+through qmail's sendmail emulation through 
++in the environment before running an \fBqmail-smtpd\fR(8) or \fBsendmail(1)\fR / \fBqmail-inject\fR(8).  DKIMSIGN will be carried
++through qmail-smtpd or through qmail's sendmail emulation through 
 +.B qmail-inject
 +to
@@ -19336,4 +18965,5 @@
 +qmail-header(5),
 +dknewkey(8),
++dkim(8),
 +dktest(8),
 +qmail-inject(8),
@@ -19354,8 +18984,26 @@
 diff -ruN ../netqmail-1.06-original/qmail-dkim.c netqmail-1.06/qmail-dkim.c
 --- ../netqmail-1.06-original/qmail-dkim.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/qmail-dkim.c	2018-04-03 14:46:51.373411639 +0200
-@@ -0,0 +1,1388 @@
++++ netqmail-1.06/qmail-dkim.c	2019-06-19 09:48:44.632641078 +0200
+@@ -0,0 +1,1417 @@
 +/*
 + * $Log: qmail-dkim.c,v $
++ * Revision 1.53  2019-06-14 21:26:37+05:30  Cprogrammer
++ * added env variable HONOR_BODYLENGTHTAG to honor body length tag during verification
++ *
++ * Revision 1.52  2019-02-18 22:18:12+05:30  Cprogrammer
++ * allow DKIMVERIFY env variable in place of DKIMPRACTICE when SIGN_PRACTICE="local"
++ *
++ * Revision 1.51  2019-02-17 11:38:51+05:30  Cprogrammer
++ * set original DKIM error for SIGN_PRACTICE=local
++ *
++ * Revision 1.50  2019-02-15 21:25:04+05:30  Cprogrammer
++ * skip nosignaturedomains if domain is present in signaturedomains
++ *
++ * Revision 1.49  2018-08-08 23:58:01+05:30  Cprogrammer
++ * issue success if at lease one one good signature is found
++ *
++ * Revision 1.48  2017-09-05 12:37:16+05:30  Cprogrammer
++ * added missing DKIM_MFREE()
++ *
 + * Revision 1.47  2016-06-03 09:57:59+05:30  Cprogrammer
 + * moved qmail-multi to sbin
@@ -19819,5 +19467,5 @@
 +
 +#include <openssl/evp.h>
-+#define DKIM_MALLOC(s)     OPENSSL_malloc(s)
++#define DKIM_MALLOC(n)     OPENSSL_malloc(n)
 +#define DKIM_MFREE(s)      OPENSSL_free(s); s = NULL;
 +char           *dns_text(char *);
@@ -19958,12 +19606,13 @@
 +		DKIM_MFREE(results);
 +		return DKIM_ADSP_SCOPE;
-+	}
-+	else
++	} else
 +	if (!str_diff(results, "e=temp;")) {
 +		DKIM_MFREE(results);
 +		return DKIM_ADSP_TEMPFAIL;
 +	}
-+	if (!(query = DKIM_MALLOC(str_len("_adsp._domainkey.") + str_len(domain) + 1)))
++	if (!(query = DKIM_MALLOC(str_len("_adsp._domainkey.") + str_len(domain) + 1))) {
++		DKIM_MFREE(results);
 +		die(51, 0);
++	}
 +	sprintf(query, "_adsp._domainkey.%s", domain);
 +	results = dns_text(query);
@@ -20290,13 +19939,17 @@
 +
 +int
-+checkPractice(int dkimRet)
++checkPractice(int dkimRet, int useADSP, int useSSP)
 +{
 +	char           *ptr;
 +
-+	if (!(ptr = env_get("DKIMPRACTICE")))
-+		return (0);
-+	else
++	if (!(ptr = env_get("DKIMPRACTICE"))) {
++		/*- if SIGN_PRACTICE="local" then you can use DKIMVERIFY env variable too */
++		if (!useADSP && !useSSP) 
++			dkimpractice = dkimverify; /*- DKIMVERIFY env variable */
++		else
++			return (0);
++	} else
 +		dkimpractice = ptr;
-+	if (!*ptr) {
++	if (!*dkimpractice) {
 +		if (dkimRet < 0 || dkimRet == DKIM_3PS_SIGNATURE)
 +			return (1);
@@ -20525,6 +20178,5 @@
 +			useADSP = 1;
 +			accept3ps = 1;
-+		}
-+		else
++		} else
 +		if (!str_diffn("ssp", x, 3)) {
 +			useSSP = 1;
@@ -20548,4 +20200,5 @@
 +			vopts.nAllowUnsignedFromHeaders = 1;
 +		vopts.nSubjectRequired = env_get("UNSIGNED_SUBJECT") ? 0 : 1;
++		vopts.nHonorBodyLengthTag = env_get("HONOR_BODYLENGTHTAG") ? 0 : 1;
 +		DKIMVerifyInit(&ctxt, &vopts);		/*- this is always successful */
 +	}
@@ -20611,8 +20264,10 @@
 +					maybe_die_dkim(ret);
 +				else
-+				for (ret = DKIM_SUCCESS,i = 0; i < nSigCount; i++) {
-+					if (pDetails[i].nResult < 0) {
-+						ret = pDetails[i].nResult;
-+						break; /*- don't know if it is right to break */
++				for (ret = DKIM_FAIL,i = 0; i < nSigCount; i++) {
++					if (pDetails[i].nResult >= 0) {
++						ret = 0;
++					} else {
++						if (ret == DKIM_FAIL)
++							ret = pDetails[i].nResult;
 +					}
 +				}
@@ -20621,6 +20276,7 @@
 +			}
 +			/*- what to do if DKIM Verification fails */
-+			if (checkPractice(ret)) {
++			if (checkPractice(ret, useADSP, useSSP)) {
 +				char           *domain;
++				int             skip_nosignature_domain = 0;
 +
 +				origRet = ret;
@@ -20635,5 +20291,6 @@
 +						len += ((token_len = str_len(p)) + 1); /*- next domain */
 +						if (!case_diffb(p, token_len, domain)) {
-+							ret = DKIM_FAIL;
++							ret = origRet;
++							skip_nosignature_domain = 1;
 +							useADSP = 0;
 +							useSSP = 0;
@@ -20642,19 +20299,21 @@
 +						p = sigdomains.s + len;
 +					}
-+					if (!(p = env_get("NOSIGNATUREDOMAINS"))) {
-+						if (control_readfile(&nsigdomains, "nosignaturedomains", 0) == -1)
-+							die(55, 2);
-+					} else
-+					if (!stralloc_copys(&nsigdomains, p))
-+						die(51, 2);
-+					for (len = 0, p = nsigdomains.s;len < nsigdomains.len;) {
-+						len += ((token_len = str_len(p)) + 1); /*- next domain */
-+						if (*p == '*' || !case_diffb(p, token_len, domain)) {
-+							ret = DKIM_NEUTRAL;
-+							useADSP = 0;
-+							useSSP = 0;
-+							break;
++					if (!skip_nosignature_domain) {
++						if (!(p = env_get("NOSIGNATUREDOMAINS"))) {
++							if (control_readfile(&nsigdomains, "nosignaturedomains", 0) == -1)
++								die(55, 2);
++						} else
++						if (!stralloc_copys(&nsigdomains, p))
++							die(51, 2);
++						for (len = 0, p = nsigdomains.s;len < nsigdomains.len;) {
++							len += ((token_len = str_len(p)) + 1); /*- next domain */
++							if (*p == '*' || !case_diffb(p, token_len, domain)) {
++								ret = DKIM_NEUTRAL;
++								useADSP = 0;
++								useSSP = 0;
++								break;
++							}
++							p = nsigdomains.s + len;
 +						}
-+						p = nsigdomains.s + len;
 +					}
 +				}
@@ -20677,5 +20336,5 @@
 +					int             bTestingPractices = 0;
 +					char           *domain;
-+	
++
 +					if ((domain = DKIMVerifyGetDomain(&ctxt)))
 +						resDKIMSSP = checkSSP(domain, &bTestingPractices);
@@ -20740,5 +20399,5 @@
 +getversion_qmail_dkim_c()
 +{
-+	static char    *x = "$Id: qmail-dkim.c,v 1.37 2013-01-24 22:37:22+05:30 Cprogrammer Exp mbhangui $";
++	static char    *x = "$Id: qmail-dkim.c,v 1.49 2018-08-08 23:58:01+05:30 Cprogrammer Exp mbhangui $";
 +
 +	x++;
@@ -20746,5 +20405,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-inject.c netqmail-1.06/qmail-inject.c
 --- ../netqmail-1.06-original/qmail-inject.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-inject.c	2016-11-22 21:03:57.120527832 +0100
++++ netqmail-1.06/qmail-inject.c	2019-02-27 20:57:13.397024992 +0100
 @@ -22,6 +22,7 @@
  #include "auto_qmail.h"
@@ -20798,5 +20457,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-local.c netqmail-1.06/qmail-local.c
 --- ../netqmail-1.06-original/qmail-local.c	2007-11-30 21:22:54.000000000 +0100
-+++ netqmail-1.06/qmail-local.c	2018-01-01 12:10:21.981102868 +0100
++++ netqmail-1.06/qmail-local.c	2019-02-27 20:57:13.398024981 +0100
 @@ -28,6 +28,7 @@
  #include "myctime.h"
@@ -20877,5 +20536,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-lspawn.c netqmail-1.06/qmail-lspawn.c
 --- ../netqmail-1.06-original/qmail-lspawn.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-lspawn.c	2016-11-22 21:03:57.120527832 +0100
++++ netqmail-1.06/qmail-lspawn.c	2019-02-27 20:57:13.398024981 +0100
 @@ -1,4 +1,5 @@
  #include "fd.h"
@@ -20906,5 +20565,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-newmvrt.c netqmail-1.06/qmail-newmvrt.c
 --- ../netqmail-1.06-original/qmail-newmvrt.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/qmail-newmvrt.c	2016-11-22 21:04:20.041763530 +0100
++++ netqmail-1.06/qmail-newmvrt.c	2019-02-27 20:57:13.398024981 +0100
 @@ -0,0 +1,70 @@
 +#include "strerr.h"
@@ -20980,5 +20639,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-pop3d.c netqmail-1.06/qmail-pop3d.c
 --- ../netqmail-1.06-original/qmail-pop3d.c	2007-11-30 21:22:54.000000000 +0100
-+++ netqmail-1.06/qmail-pop3d.c	2016-11-22 21:03:57.121527799 +0100
++++ netqmail-1.06/qmail-pop3d.c	2019-02-27 20:57:13.398024981 +0100
 @@ -16,6 +16,11 @@
  #include "readwrite.h"
@@ -21140,5 +20799,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-pw2u.c netqmail-1.06/qmail-pw2u.c
 --- ../netqmail-1.06-original/qmail-pw2u.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-pw2u.c	2016-11-22 21:03:57.121527799 +0100
++++ netqmail-1.06/qmail-pw2u.c	2019-02-27 20:57:13.398024981 +0100
 @@ -1,3 +1,4 @@
 +#include <unistd.h>
@@ -21148,5 +20807,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-qmqpc.c netqmail-1.06/qmail-qmqpc.c
 --- ../netqmail-1.06-original/qmail-qmqpc.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-qmqpc.c	2016-11-22 21:03:57.121527799 +0100
++++ netqmail-1.06/qmail-qmqpc.c	2019-02-27 20:57:13.398024981 +0100
 @@ -102,6 +102,8 @@
  char *server;
@@ -21169,5 +20828,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-qmtpd.c netqmail-1.06/qmail-qmtpd.c
 --- ../netqmail-1.06-original/qmail-qmtpd.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-qmtpd.c	2016-11-22 21:03:57.121527799 +0100
++++ netqmail-1.06/qmail-qmtpd.c	2019-02-27 20:57:13.399024970 +0100
 @@ -1,3 +1,5 @@
 +#include <unistd.h>
@@ -21178,5 +20837,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-qstat.sh netqmail-1.06/qmail-qstat.sh
 --- ../netqmail-1.06-original/qmail-qstat.sh	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-qstat.sh	2016-11-22 21:03:57.121527799 +0100
++++ netqmail-1.06/qmail-qstat.sh	2019-02-27 20:57:13.399024970 +0100
 @@ -1,7 +1,7 @@
  cd QMAIL
@@ -21191,5 +20850,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-queue.8 netqmail-1.06/qmail-queue.8
 --- ../netqmail-1.06-original/qmail-queue.8	2007-11-30 21:22:54.000000000 +0100
-+++ netqmail-1.06/qmail-queue.8	2016-12-05 19:24:19.597680897 +0100
++++ netqmail-1.06/qmail-queue.8	2019-02-27 20:57:13.399024970 +0100
 @@ -46,6 +46,13 @@
  will invoke the contents of
@@ -21208,5 +20867,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-queue.c netqmail-1.06/qmail-queue.c
 --- ../netqmail-1.06-original/qmail-queue.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-queue.c	2016-12-05 19:24:19.597680897 +0100
++++ netqmail-1.06/qmail-queue.c	2019-02-27 20:57:13.399024970 +0100
 @@ -16,6 +16,8 @@
  #include "auto_uids.h"
@@ -21360,5 +21019,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-remote.8 netqmail-1.06/qmail-remote.8
 --- ../netqmail-1.06-original/qmail-remote.8	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-remote.8	2016-11-22 21:03:57.122527765 +0100
++++ netqmail-1.06/qmail-remote.8	2019-02-27 20:57:13.399024970 +0100
 @@ -100,6 +100,73 @@
  After this letter comes a human-readable description of
@@ -21643,5 +21302,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-remote.c netqmail-1.06/qmail-remote.c
 --- ../netqmail-1.06-original/qmail-remote.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-remote.c	2017-08-28 17:51:47.068287985 +0200
++++ netqmail-1.06/qmail-remote.c	2020-04-16 11:23:31.333050380 +0200
 @@ -28,6 +28,7 @@
  #include "timeoutconn.h"
@@ -21716,5 +21375,5 @@
    if (flagcritical) out("Possible duplicate! ");
 +#ifdef TLS
-+  if (ssl_err_str) { out(ssl_err_str); out(" "); }
++  if (ssl_err_str) { out((char *)ssl_err_str); out(" "); }
 +#endif
    out("(#4.4.2)\n");
@@ -21813,5 +21472,5 @@
  {
    int i; 
-@@ -179,6 +284,11 @@
+@@ -179,6 +284,16 @@
  char *prepend;
  char *append;
@@ -21819,11 +21478,16 @@
 +#ifdef TLS
 +  /* shouldn't talk to the client unless in an appropriate state */
++#if OPENSSL_VERSION_NUMBER >= 0x10100000L
++  OSSL_HANDSHAKE_STATE state = ssl ? SSL_get_state(ssl) : TLS_ST_BEFORE;
++  if (state & TLS_ST_OK || (!smtps && state & TLS_ST_BEFORE))
++#else
 +  int state = ssl ? ssl->state : SSL_ST_BEFORE;
 +  if (state & SSL_ST_OK || (!smtps && state & SSL_ST_BEFORE))
++#endif
 +#endif
    substdio_putsflush(&smtpto,"QUIT\r\n");
    /* waiting for remote side is just too ridiculous */
    out(prepend);
-@@ -186,6 +296,30 @@
+@@ -186,6 +301,30 @@
    out(append);
    out(".\n");
@@ -21856,5 +21520,5 @@
  }
  
-@@ -201,6 +335,16 @@
+@@ -201,6 +340,16 @@
      if (ch == '.')
        substdio_put(&smtpto,".",1);
@@ -21873,5 +21537,5 @@
        r = substdio_get(&ssin,&ch,1);
        if (r == 0) perm_partialline();
-@@ -214,30 +358,432 @@
+@@ -214,30 +363,436 @@
    substdio_flush(&smtpto);
  }
@@ -21885,5 +21549,5 @@
 +void tls_quit(const char *s1, const char *s2)
 +{
-+  out(s1); if (s2) { out(": "); out(s2); } TLS_QUIT;
++  out((char *)s1); if (s2) { out(": "); out((char *)s2); } TLS_QUIT;
 +}
 +# define tls_quit_error(s) tls_quit(s, ssl_error())
@@ -21949,5 +21613,5 @@
 +    if (!len) {
 +      if (!servercert) return 0;
-+      out("ZNo TLS achieved while "); out(servercert);
++      out("ZNo TLS achieved while "); out((char *)servercert);
 +      out(" exists"); smtptext.len = 0; TLS_QUIT;
 +    }
@@ -21980,4 +21644,8 @@
 +    SSL_CTX_use_RSAPrivateKey_file(ctx, CLIENTCERT, SSL_FILETYPE_PEM);
 +# undef CLIENTCERT
++
++#if OPENSSL_VERSION_NUMBER >= 0x10101000L
++  SSL_CTX_set_post_handshake_auth(ctx, 1);
++#endif
 +
 +  myssl = SSL_new(ctx);
@@ -22011,5 +21679,5 @@
 +      if (!servercert) return 0;
 +      out("ZSTARTTLS rejected while ");
-+      out(servercert); out(" exists"); TLS_QUIT;
++      out((char *)servercert); out(" exists"); TLS_QUIT;
 +    }
 +    smtptext.len = 0;
@@ -22063,5 +21731,5 @@
 +      i = X509_NAME_get_index_by_NID(subj, NID_commonName, -1);
 +      if (i >= 0) {
-+        const ASN1_STRING *s = X509_NAME_get_entry(subj, i)->value;
++        const ASN1_STRING *s = X509_NAME_ENTRY_get_data(X509_NAME_get_entry(subj, i));
 +        if (s) { peer.len = s->length; peer.s = s->data; }
 +      }
